// Klasse Konto

class Konto {
  protected:
     int derKontostand;
  public:
  Konto(int p_SBetrag);
  Konto(void);
  int gibKontostand(void);
  void buchen(int p_Betrag);
  };

Konto::Konto(int p_SBetrag){
derKontostand = p_SBetrag;
}

Konto::Konto(void){
derKontostand = 0;
}

int Konto::gibKontostand(void){
    return derKontostand;
}

void Konto::buchen(int p_Betrag){
derKontostand = derKontostand + p_Betrag;
}
//------------------------------------------------------
class Sparkonto : public Konto

{
public:
   Sparkonto(int p_Mindesteinlage);
   void buchen(int p_Betrag);
protected:
   int a_Mindesteinlage;
};

//Operationen
Sparkonto::Sparkonto(int p_Mindesteinlage){
derKontostand = p_Mindesteinlage;
a_Mindesteinlage =  p_Mindesteinlage;
}

void Sparkonto::buchen(int p_Betrag){
if(derKontostand + p_Betrag >= a_Mindesteinlage)
        derKontostand = derKontostand + p_Betrag;

}
//---------------------------------------------------------------------------

class Girokonto : public Konto
{
public:
   Girokonto(int p_Kreditlimit);
   Girokonto(void);
   void buchen(int p_Betrag);
protected:
   int a_Kreditlimit;
};

//Operationen
Girokonto::Girokonto(int p_Kreditlimit){
derKontostand = 0.00;
a_Kreditlimit =  - p_Kreditlimit;
}

Girokonto::Girokonto(void){
derKontostand = 0.00;
a_Kreditlimit =  0.00;
}

void Girokonto::buchen(int p_Betrag){
if(derKontostand + p_Betrag >= a_Kreditlimit)
        derKontostand = derKontostand + p_Betrag;
}
